<?php

namespace Teknisa\FIS\Modules\Apuracoes\Factories;

use Doctrine\ORM\EntityManager;
use Zeedhi\Framework\DB\StoredProcedure\Param;
use Zeedhi\Framework\DB\StoredProcedure\StoredProcedure;


class Fis41000ApuracaoAutomaticaFactory {
    protected $connection;
    protected $entityManager;

    public function __construct(EntityManager $entityManager) {
        $this->connection = $entityManager->getConnection();
        $this->entityManager = $entityManager;
    }

    public function getAgrupamento($cdgrupinscesta) {
        $sql = "SELECT * FROM GRUPINSCESTA 
                WHERE CDGRUPINSCESTA = :CDGRUPINSCESTA";

        $params = array(
            'CDGRUPINSCESTA' => $cdgrupinscesta
        );
        
        $std = $this->connection->prepare($sql);
        $std->execute($params);
        return $std->fetchAll();
    }
    
    public function insertApuraAuto($row) {
        $sql = "INSERT INTO MAPAAPURACAUTO (
                                NRSEQUJOB,
                                DTJOBAPURAC,
                                NRSEQUMAPAPU,
                                CDEMPRESA,
                                CDINSCESTA,
                                CDINSCESTARRAY,
                                CDINSCMUNI,
                                CDIMPOSTO,
                                DTINIPERIODO,
                                DTFIMPERIODO,
                                NMMAPAAPUR,
                                CDRECEGUIA,
                                CDRECECUMU,
                                CDRECENCUMU,
                                DTVENCGUIA,
                                NRORG,
                                IDATIVO,
                                DTINCLUSAO,
                                DTULTATU,
                                NRORGINCLUSAO,
                                CDOPERINCLUSAO,
                                NRORGULTATU,
                                CDOPERULTATU,
                                IDSTATUS,
                                IDTPAPURACAO,
                                DTVDPERIODO,
                                CDGRUPINSCESTA,
                                IDTPAPAUTO
                            ) VALUES (
                                :NRSEQUJOB,
                                :DTJOBAPURAC,
                                :NRSEQUMAPAPU,
                                :CDEMPRESA,
                                :CDINSCESTA,
                                :CDINSCESTARRAY,
                                :CDINSCMUNI,
                                :CDIMPOSTO,
                                :DTINIPERIODO,
                                :DTFIMPERIODO,
                                :NMMAPAAPUR,
                                :CDRECEGUIA,
                                :CDRECECUMU,
                                :CDRECENCUMU,
                                :DTVENCGUIA,
                                :NRORG,
                                :IDATIVO,
                                :DTINCLUSAO,
                                :DTULTATU,
                                :NRORGINCLUSAO,
                                :CDOPERINCLUSAO,
                                :NRORGULTATU,
                                :CDOPERULTATU,
                                :IDSTATUS,
                                :IDTPAPURACAO,
                                :DTVDPERIODO,
                                :CDGRUPINSCESTA,
                                :IDTPAPAUTO
                            )";

        $params = array (
                    'NRSEQUJOB' => $row['NRSEQUJOB'],
                    'DTJOBAPURAC' => $row['DTJOBAPURAC'],
                    'NRSEQUMAPAPU' => isset($row['NRSEQUMAPAPU']) ? $row['NRSEQUMAPAPU'] : null,
                    'CDEMPRESA' => $row['CDEMPRESA'],
                    'CDINSCESTA' => isset($row['CDINSCESTA']) ? $row['CDINSCESTA'] : null,
                    'CDINSCESTARRAY' => isset($row['CDINSCESTARRAY']) ? $row['CDINSCESTARRAY'] : null,
                    'CDINSCMUNI' => isset($row['CDINSCMUNI']) ? $row['CDINSCMUNI'] : null,
                    'CDIMPOSTO' => $row['CDIMPOSTO'],
                    'DTINIPERIODO' => $row['DTINIPERIODO'],
                    'DTFIMPERIODO' => $row['DTFIMPERIODO'],
                    'NMMAPAAPUR' => isset($row['NMMAPAAPUR']) ? $row['NMMAPAAPUR'] : null,
                    'CDRECEGUIA' => isset($row['CDRECEGUIA']) ? $row['CDRECEGUIA'] : null,
                    'CDRECECUMU' => isset($row['CDRECECUMU']) ? $row['CDRECECUMU'] : null,
                    'CDRECENCUMU' => isset($row['CDRECENCUMU']) ? $row['CDRECENCUMU'] : null,
                    'DTVENCGUIA' => isset($row['DTVENCGUIA']) ? $row['DTVENCGUIA'] : null,
                    'NRORG' => $row['NRORG'],
                    'IDATIVO' => 'S',
                    'DTINCLUSAO' => $row['DTINCLUSAO'],
                    'DTULTATU' => $row['DTINCLUSAO'],
                    'NRORGINCLUSAO' => $row['NRORG'],
                    'CDOPERINCLUSAO' => $row['CDOPERADOR'],
                    'NRORGULTATU' => $row['NRORG'],
                    'CDOPERULTATU' => $row['CDOPERADOR'],
                    'IDSTATUS' => $row['IDSTATUS'],
                    'IDTPAPURACAO' => $row['IDTPAPURACAO'],
                    'DTVDPERIODO' => $row['DTVDPERIODO'],
                    'CDGRUPINSCESTA' => isset($row['CDGRUPINSCESTA']) ? $row['CDGRUPINSCESTA'] : null,
                    'IDTPAPAUTO' => $row['IDTPAPAUTO']
                );
                
        $std = $this->connection->prepare($sql);
        $std->execute($params);
        
    }
    
    public function updateApuraAuto($row) {
        $sql = "UPDATE MAPAAPURACAUTO SET
                                DTJOBAPURAC = :DTJOBAPURAC,
                                NRSEQUMAPAPU = :NRSEQUMAPAPU,
                                CDINSCESTA = :CDINSCESTA,
                                CDINSCESTARRAY = :CDINSCESTARRAY,
                                CDINSCMUNI = :CDINSCMUNI,
                                DTINIPERIODO = :DTINIPERIODO,
                                DTFIMPERIODO = :DTFIMPERIODO,
                                NMMAPAAPUR = :NMMAPAAPUR,
                                CDRECEGUIA = :CDRECEGUIA,
                                CDRECECUMU = :CDRECECUMU,
                                CDRECENCUMU = :CDRECENCUMU,
                                DTVENCGUIA = :DTVENCGUIA,
                                DTULTATU = :DTULTATU,
                                NRORGULTATU = :NRORGULTATU,
                                CDOPERULTATU = :CDOPERULTATU,
                                IDSTATUS = :IDSTATUS,
                                IDTPAPURACAO = :IDTPAPURACAO,
                                DTVDPERIODO = :DTVDPERIODO,
                                CDGRUPINSCESTA = :CDGRUPINSCESTA,
                                IDTPAPAUTO = :IDTPAPAUTO
                                WHERE NRSEQUJOB = :NRSEQUJOB
                                AND CDEMPRESA = :CDEMPRESA
                                AND CDIMPOSTO = :CDIMPOSTO
                                AND NRORG = :NRORG";

        $params = array (
                    'NRSEQUJOB' => $row['NRSEQUJOB'],
                    'DTJOBAPURAC' => $row['DTJOBAPURAC'],
                    'NRSEQUMAPAPU' => isset($row['NRSEQUMAPAPU']) ? $row['NRSEQUMAPAPU'] : null,
                    'CDEMPRESA' => $row['CDEMPRESA'],
                    'CDINSCESTA' => isset($row['CDINSCESTA']) ? $row['CDINSCESTA'] : null,
                    'CDINSCESTARRAY' => isset($row['CDINSCESTARRAY']) ? $row['CDINSCESTARRAY'] : null,
                    'CDINSCMUNI' => isset($row['CDINSCMUNI']) ? $row['CDINSCMUNI'] : null,
                    'CDIMPOSTO' => $row['CDIMPOSTO'],
                    'DTINIPERIODO' => $row['DTINIPERIODO'],
                    'DTFIMPERIODO' => $row['DTFIMPERIODO'],
                    'NMMAPAAPUR' => isset($row['NMMAPAAPUR']) ? $row['NMMAPAAPUR'] : null,
                    'CDRECEGUIA' => isset($row['CDRECEGUIA']) ? $row['CDRECEGUIA'] : null,
                    'CDRECECUMU' => isset($row['CDRECECUMU']) ? $row['CDRECECUMU'] : null,
                    'CDRECENCUMU' => isset($row['CDRECENCUMU']) ? $row['CDRECENCUMU'] : null,
                    'DTVENCGUIA' => isset($row['DTVENCGUIA']) ? $row['DTVENCGUIA'] : null,
                    'NRORG' => $row['NRORG'],
                    'DTULTATU' => $row['DTINCLUSAO'],
                    'NRORGULTATU' => $row['NRORG'],
                    'CDOPERULTATU' => $row['CDOPERADOR'],
                    'IDSTATUS' => 'P',
                    'IDTPAPURACAO' => $row['IDTPAPURACAO'],
                    'DTVDPERIODO' => $row['DTVDPERIODO'],
                    'CDGRUPINSCESTA' => isset($row['CDGRUPINSCESTA']) ? $row['CDGRUPINSCESTA'] : null,
                    'IDTPAPAUTO' => $row['IDTPAPAUTO']
                );
                
        $std = $this->connection->prepare($sql);
        $std->execute($params);
        
    }
    
    public function selectApuraAutoExec($row){
        $sql = "SELECT * FROM MAPAAPURACAUTO WHERE NRSEQUJOB = :NRSEQUJOB";

        $params = array(
            'NRSEQUJOB' => $row['NRSEQUJOB']
        );
        
        $std = $this->connection->prepare($sql);
        $std->execute($params);
        return $std->fetchAll();
    }
    
    public function getApuraAutoInsert($row) {
        // Query a ser executada.
        $sql = "SELECT * FROM MAPAAPURACAUTO 
                    WHERE NRSEQUJOB = :NRSEQUJOB";

        $params = array(
            "NRSEQUJOB"=>$row["NRSEQUJOB"]
        );
        
        // Prepara o statement da query para execução.
        $std = $this->connection->prepare($sql);
        
        // Executa o statement com os paràmetros passados.
        $std->execute($params);
        
        // Executa um fetch no primeiro dado, retornando-o.
        return $std->fetchAll();
    }
    
    public function getConfiguraSMTP($row)  {
        // Query a ser executada.
        $sql = "SELECT * FROM CONFIGURASMTP
                    WHERE NRORG = :NRORG";
        
        $params = array(
            "NRORG"=> $row["NRORG"]
        );
        // Prepara o statement da query para execução.
        $std = $this->connection->prepare($sql);
        
        // Executa o statement com os paràmetros passados.
        $std->execute($params);
        
        // Executa um fetch no primeiro dado, retornando-o.
        //var_dump($std->fetchAll());
        return $std->fetchAll();
    }
    
    public function getContatos($row)  {
        // Query a ser executada.
        $sql = "SELECT * FROM CONTATOAPURAC
                    WHERE NRORG = :NRORG
                    AND CDEMPRESA = :CDEMPRESA
                    AND IDAPURAAUTO = 'S'";
        
        $params = array(
            "NRORG"=> $row["NRORG"],
            "CDEMPRESA"=> $row["CDEMPRESA"]
        );
        // Prepara o statement da query para execução.
        $std = $this->connection->prepare($sql);
        
        // Executa o statement com os paràmetros passados.
        $std->execute($params);
        
        // Executa um fetch no primeiro dado, retornando-o.
        //var_dump($std->fetchAll());
        return $std->fetchAll();
    }
    
    public function getNmEmpresa($row) {
        // Query a ser executada.
        $sql = "SELECT NMEMPRESA FROM EMPRESA
                    WHERE CDEMPRESA = :CDEMPRESA
                    AND NRORG = :NRORG";
        
        $params = array(
            "CDEMPRESA"=> $row["CDEMPRESA"],
            "NRORG"=> $row["NRORG"]
        );
        
        // Prepara o statement da query para execução.
        $std = $this->connection->prepare($sql);
        
        // Executa o statement com os paràmetros passados.
        $std->execute($params);
        
        // Executa um fetch no primeiro dado, retornando-o.
        //var_dump($std->fetchAll());
        return $std->fetch();
    }
    
    public function verificaMapaApura($row){
        $sql = "SELECT * FROM MAPAAPURAC
                    WHERE CDIMPOSTO = :CDIMPOSTO
                    AND CDEMPRESA = :CDEMPRESA
                    AND CDINSCESTA = :CDINSCESTA
                    AND DTINIPERIODO = :DTINIPERIODO
                    AND DTFIMPERIODO = :DTFIMPERIODO";

        $params = array(
            'CDIMPOSTO' => $row['CDIMPOSTO'],
            'CDEMPRESA' => $row['CDEMPRESA'],
            'CDINSCESTA' => isset($row['CDINSCESTA']) ? $row['CDINSCESTA'] : null,
            'DTINIPERIODO' => substr($row['DTINIPERIODO'], 0, 10),
            'DTFIMPERIODO' => substr($row['DTFIMPERIODO'], 0, 10)
        );
        
        $std = $this->connection->prepare($sql);
        $std->execute($params);
        return $std->fetch();
    }
    
    public function getInscrestadEmpresa($row) {
        // Query a ser executada.
        $sql = "SELECT * FROM INSCRESTAD 
                    WHERE CDEMPRESA = :CDEMPRESA";

        $params = array(
            "CDEMPRESA"=>$row["CDEMPRESA"]
        );
        
        // Prepara o statement da query para execução.
        $std = $this->connection->prepare($sql);
        
        // Executa o statement com os paràmetros passados.
        $std->execute($params);
        
        // Executa um fetch no primeiro dado, retornando-o.
        return $std->fetchAll();
    }
    
    public function buscaUltimoMapa($row) {
        $sql = "SELECT * FROM
                        MAPAAPURAC
                    WHERE
                        DTINIPERIODO = (
                            SELECT
                                MAX(DTINIPERIODO)
                            FROM
                                MAPAAPURAC M
                            WHERE
                                NRORG =:NRORG
                                AND CDEMPRESA =:CDEMPRESA
                                AND CDIMPOSTO =:CDIMPOSTO
                                AND (:IDTIPOAPURA <> 'E'
                                     OR CDINSCESTA =:CDINSCESTA )
                                AND (:IDTIPOAPURA <> 'M'
                                     OR CDINSCMUNI =:CDINSCMUNI )
                        )
                        AND NRORG =:NRORG
                        AND CDEMPRESA =:CDEMPRESA
                        AND CDIMPOSTO =:CDIMPOSTO
                        AND (:IDTIPOAPURA <> 'E'
                             OR CDINSCESTA =:CDINSCESTA )
                        AND (:IDTIPOAPURA <> 'M'
                             OR CDINSCMUNI =:CDINSCMUNI )";
        
        $params = array(
            'NRORG'         => $row['NRORG'],
            'CDEMPRESA'     => $row['CDEMPRESA'],
            'CDIMPOSTO'     => $row['CDIMPOSTO'],
            'CDINSCESTA'    => isset($row['CDINSCESTA']) ? $row['CDINSCESTA'] : null,
            'CDINSCMUNI'    => isset($row['CDINSCMUNI']) ? $row['CDINSCMUNI'] : null,
            'IDTIPOAPURA'   => $row['IDTIPOAPURA']
        );
        
        $std = $this->connection->prepare($sql);
        $std->execute($params);
        return $std->fetch();
    }
    
    public function buscaTipoApura($cdimposto) {
        $sql = "SELECT INF.IDORGARRECADNFE  
                    FROM IMPOSTO I, IMPOSTONFE INF 
                    WHERE I.CDIMPOSTO = :CDIMPOSTO
                    AND INF.IDORGARRECADNFE IS NOT NULL
                    AND INF.CDIMPOSTONFE = I.CDIMPOSTONFE";
        
        $params = array(
            'CDIMPOSTO' => $cdimposto
        );
        
        $std = $this->connection->prepare($sql);
        $std->execute($params);
        return $std->fetch();
    }
    
    public function getMapaApurac($nrsequmapapu) {
        $sql = "SELECT * FROM MAPAAPURAC 
                    WHERE NRSEQUMAPAPU = :NRSEQUMAPAPU";
        
        $params = array(
            'NRSEQUMAPAPU' => $nrsequmapapu
        );
        
        $std = $this->connection->prepare($sql);
        $std->execute($params);
        return $std->fetch();
    }
    
    public function insertMapaApurac($row){
        $sql = "INSERT INTO MAPAAPURAC (
                            NRSEQUMAPAPU,
                            CDEMPRESA,
                            CDINSCESTA,
                            CDINSCMUNI,
                            CDIMPOSTO,
                            DTINIPERIODO,
                            DTFIMPERIODO,
                            NMMAPAAPUR,
                            IDBLOQMAPAPU,
                            IDVRRECEGUIAMANUAL,
                            IDTPMAPAAPURAC,
                            NRORG,
                            VRTTCTBLDEB,
                            VRTTBACALDEB,
                            VRTTCTBLCRE,
                            VRTTBACALCRE,
                            VRTOTAIMPOS,
                            VRRECEGUIA,
                            VRMULTAGUIA,
                            VRJUROGUIA,
                            VRTOTAGUIA,
                            VRCOMPENSA
                        ) VALUES (
                            :NRSEQUMAPAPU,
                            :CDEMPRESA,
                            :CDINSCESTA,
                            :CDINSCMUNI,
                            :CDIMPOSTO,
                            :DTINIPERIODO,
                            :DTFIMPERIODO,
                            :NMMAPAAPUR,
                            :IDBLOQMAPAPU,
                            :IDVRRECEGUIAMANUAL,
                            :IDTPMAPAAPURAC,
                            :NRORG,
                            :VRTTCTBLDEB,
                            :VRTTBACALDEB,
                            :VRTTCTBLCRE,
                            :VRTTBACALCRE,
                            :VRTOTAIMPOS,
                            :VRRECEGUIA,
                            :VRMULTAGUIA,
                            :VRJUROGUIA,
                            :VRTOTAGUIA,
                            :VRCOMPENSA
                        )";
        
        $params = array(
            'NRSEQUMAPAPU'          => $row['NRSEQUMAPAPU'],
            'CDEMPRESA'             => $row['CDEMPRESA'],
            'CDINSCESTA'            => isset($row['CDINSCESTA']) ? $row['CDINSCESTA'] : null,
            'CDINSCMUNI'            => isset($row['CDINSCMUNI']) ? $row['CDINSCMUNI'] : null,
            'CDIMPOSTO'             => $row['CDIMPOSTO'],
            'DTINIPERIODO'          => substr($row['DTINIPERIODO'], 0, 10),
            'DTFIMPERIODO'          => substr($row['DTFIMPERIODO'], 0, 10),
            'NMMAPAAPUR'            => 'Apuração Automática '.floatval($row['NRSEQUJOB']),
            'IDBLOQMAPAPU'          => 'N',
            'IDVRRECEGUIAMANUAL'    =>'N',
            'IDTPMAPAAPURAC'        => 'N',
            'NRORG'                 => $row['NRORG'],
            'VRTTCTBLDEB'           => 0,
            'VRTTBACALDEB'          => 0,
            'VRTTCTBLCRE'           => 0,
            'VRTTBACALCRE'          => 0,
            'VRTOTAIMPOS'           => 0,
            'VRRECEGUIA'            => 0,
            'VRMULTAGUIA'           => 0,
            'VRJUROGUIA'            => 0,
            'VRTOTAGUIA'            => 0,
            'VRCOMPENSA'            => 0
        );
        
        $std = $this->connection->prepare($sql);
        $std->execute($params);
    }
    
    public function verificaArquivo($row) {
        $sql = "SELECT * FROM ARQMAPAAPURAUTO
                WHERE NRSEQUMAPAPU = :NRSEQUMAPAPU
                AND NMARQUIVO = :NMARQUIVO";
        
        $params = array(
            "NRSEQUMAPAPU" => $row["NRSEQUMAPAPU"],
            "NMARQUIVO" => $row["NMARQUIVO"]
        );
        
        // Prepara o statement da query para execução.
        $std = $this->connection->prepare($sql);
        
        // Executa o statement com os paràmetros passados.
        $std->execute($params);
        
        // Executa um fetch no primeiro dado, retornando-o.
        return $std->fetchAll();
    }
    
    public function insertArquivo($row) {
        $sql = "INSERT INTO ARQMAPAAPURAUTO
            ( 
                NRORG,
                NRARQUIVO,
                NRSEQUJOB,
                NRSEQUMAPAPU,
                CDEMPRESA,
                CDINSCESTA,
                DTAGENDAMENTO,
                DTEXECAGEND,
                NMARQUIVO,
                NMPATHARQ
            )
             VALUES (
                :NRORG,
                :NRARQUIVO,
                :NRSEQUJOB,
                :NRSEQUMAPAPU,
                :CDEMPRESA,
                :CDINSCESTA,
                :DTAGENDAMENTO,
                :DTEXECAGEND,
                :NMARQUIVO,
                :NMPATHARQ  )";
        
        $params = array(
            "NRORG" => $row["NRORG"],
            "NRARQUIVO" => $row["NRARQUIVO"],
            "NRSEQUJOB" => $row["NRSEQUJOB"],
            "NRSEQUMAPAPU" => $row["NRSEQUMAPAPU"],
            "CDEMPRESA" => $row["CDEMPRESA"],
            "CDINSCESTA" => $row["CDINSCESTA"],
            "DTAGENDAMENTO" => $row["DTJOBAPURAC"],
            "DTEXECAGEND" => $row["DTEXECAGEND"],
            "NMARQUIVO" => $row["NMARQUIVO"],
            "NMPATHARQ" => $row["NMPATHARQ"]
            
        );
        
        $std = $this->connection->prepare($sql);
        $std->execute($params);
    }
    
    public function updateStatusMapaApuracAuto($row) {
        $sql = "UPDATE MAPAAPURACAUTO 
                SET IDSTATUS = 'R' 
                WHERE NRSEQUJOB = :NRSEQUJOB";
        
        $params = array(
            "NRSEQUJOB" => $row["NRSEQUJOB"],
        );
        
        $std = $this->connection->prepare($sql);
        $std->execute($params);
    }
    
    public function getArquivosUpdate($row) {
        $sql = "SELECT * FROM ARQMAPAAPURAUTO 
                WHERE NRSEQUJOB = :NRSEQUJOB";
        
        $params = array(
            "NRSEQUJOB" => $row["NRSEQUJOB"],
        );
        
        $std = $this->connection->prepare($sql);
        $std->execute($params);
        return $std->fetchAll();
        
    }
    
    public function deleteArquivo($row) {
        $sql = "DELETE FROM ARQMAPAAPURAUTO
                WHERE NRSEQUJOB = :NRSEQUJOB
                AND NRARQUIVO = :NRARQUIVO";
        
        $params = array(
            "NRSEQUJOB" => $row["NRSEQUJOB"],
            "NRARQUIVO" => $row["NRARQUIVO"]
        );
        
        // Prepara o statement da query para execução.
        $std = $this->connection->prepare($sql);
        
        // Executa o statement com os paràmetros passados.
        $std->execute($params);
        
    }
    
}
